<?php
/**
 * @package CafePress Ad Rotator
 * @author Matt Kendrick
 * @version 0.80
 */
/*
Plugin Name: CafePress  Ad Rotator
Plugin URI: http://mattkendrick.com/?p=1528
Description: This plugin adds a widget that displays random items from your CafePress.com store. Requires cURL and a CafePress API Key.
Author: Matt Kendrick
Version: 0.80
Author URI: http://mattkendrick.com
*/

function cp_ad_rotate_widget() {

$options = get_option("cp_ad_rotate_options");

if(is_array($options) AND $options['api_key'] != "" AND $options['store_id'] != "")
{

$buffer = get_cp_xml($options);

if($options['cache'] == "")
{
$cached = "";
}
else
{
$buffer = $options['cache'];
$cached = "*";
}

//check buffer
if($buffer != "")
{

//if php5
if(version_compare(PHP_VERSION, '5.0.0') >= 0)
{
	//echo "PHP5";
	$item = get_rnd_item_info_php5($buffer);	
}
//if php4
else
{
	//echo "PHP4";
	$item = get_rnd_item_info($buffer);
}

if(is_array($item))
{
	echo "<h2 class='widgettitle'>".$options['widget_title']."</h2>";
	echo "<div style='font-size:x-small;'>";

	//thumbnail
	echo "<a href='".$item['url']."' target='_blank'><img src='".$item['thumbnail']."'></a><br>";

	//desciprtion
	echo "<b>".$item['description'].$cached."</b><br>";

	//buy url
	echo "Price: $".number_format($item['price'], 2, '.', '')." - <a href='".$item['url']."' target='_blank'>Buy Now</a><br>";

	echo "</div><br>";
}

}
}


}

function get_cp_xml($options)
{

$url = 'http://api.cafepress.com/index.asmx/StoreLookup?storeId='.$options['store_id'].'&apiKey='.$options['api_key'].'&version=1&productTypes=';

//use curl to grab the xml data
$curl_handle=curl_init();
curl_setopt($curl_handle,CURLOPT_URL,$url);
curl_setopt($curl_handle,CURLOPT_CONNECTTIMEOUT,2);
curl_setopt($curl_handle,CURLOPT_RETURNTRANSFER,1);
$buffer = curl_exec($curl_handle);
curl_close($curl_handle);

return $buffer;

}

function get_rnd_item_info($buffer)
{

if($xmlDoc = domxml_open_mem($buffer))
{
	$header = $xmlDoc->get_elements_by_tagname("products");

	$number_of_items = $header[0]->get_attribute('total');

	$i = rand  ( 1 , $number_of_items );

	$items = $xmlDoc->get_elements_by_tagname("product");

	$item = array();

	$item['thumbnail'] = $items[$i]->get_attribute('thumbnailUrl');
	$item['url'] =  $items[$i]->get_attribute('marketplaceUrl');
	$item['price'] = $items[$i]->get_attribute('price');
	$item['description'] = $items[$i]->get_attribute('item');

	unset($xmlDoc);
}

return $item;

}

if(version_compare(PHP_VERSION, '5.0.0') >= 0){require "cp_ad_rotate_php5_functions.php";}
 
function init_cp_ad_rotate()
{ 
register_sidebar_widget("CafePress Ad Rotator", "cp_ad_rotate_widget");
register_widget_control(   'CafePress Ad Rotator', 'cp_ad_rotate_control', 300, 200 );
}

function cp_ad_rotate_control()
{

$options = get_option("cp_ad_rotate_options");
if (!is_array( $options ))
{
$options = array('api_key' => '','store_id' => '','widget_title' => '');
}    

if($_POST['cp_ad_rotate-Submit'])
{
$options['api_key'] = $_POST['cp_ad_rotate-api_key'];
$options['store_id'] = $_POST['cp_ad_rotate-store_id'];
$options['widget_title'] = $_POST['cp_ad_rotate-widget_title'];

if($_POST['cp_ad_rotate-update_cache'] == 1)
{
$options['last_cache_update'] = date(U);
$options['cache'] = get_cp_xml($options);
}

if($_POST['cp_ad_rotate-clear_cache'] == 1)
{
$options['cache'] = "";
}

update_option("cp_ad_rotate_options", $options);
}

echo "<p>
    <label for='cp_ad_rotate-widget_title'>Widget Title: </label>
    <input type='text' id='cp_ad_rotate-widget_title' name='cp_ad_rotate-widget_title' value='".$options['widget_title']."' /><br><br>
	<label for='cp_ad_rotate-store_id'>Store Id: </label>
	<input type='text' id='cp_ad_rotate-store_id' name='cp_ad_rotate-store_id' value='".$options['store_id']."' /><br><br>
	<label for='cp_ad_rotate-api_key'>API Key: </label>
    <input type='text' id='cp_ad_rotate-api_key' name='cp_ad_rotate-api_key' value='".$options['api_key']."' /><br><br>
	<label for='cp_ad_rotate-update_cache'>Update Cache: </label>
    <input type='checkbox' id='cp_ad_rotate-update_cache' name='cp_ad_rotate-update_cache' value='1' />
    <label for='cp_ad_rotate-clear_cache'>Clear Cache: </label>
    <input type='checkbox' id='cp_ad_rotate-clear_cache' name='cp_ad_rotate-clear_cache' value='1' /><br>
    <input type='hidden' id='cp_ad_rotate-Submit' name='cp_ad_rotate-Submit' value='1' />
  </p>";
  
  echo "Last Cache Update: ";
  
  if($options['cache'] == "")
  {
  echo "<font color='red'>Never</font>";
  }
  else
  {
  echo "<font color='green'>".date("l m/d/Y g:i a", $options['last_cache_update'])."</font>";
  }
  
  echo "<br><br><a href='http://developer.cafepress.com/apps/register' target='_blank'>API Key Registration</a><br><br>";
  
  echo "<a href='https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=3RY8R543SEP92' target='_blank'><img src='https://www.paypal.com/en_US/i/btn/btn_donate_SM.gif' border=1></a>";
  
  
}

add_action("plugins_loaded", "init_cp_ad_rotate");
 
?>